module Tweed
  module Monads
    class Identity < Tweed::Monad
      define_monad do
        construct { |value| @value = value }
        unit { |value| self.new(value) }
        bind { |&block| block.call(@value) }
      end
      
      def inspect
        "#{self.class.inspect}[#{@value.inspect}]"
      end
      
      def ==(other)
        if other.is_a? Identity
          @value == other.instance_eval { @value }
        else
          @value == other
        end
      end
    end # class Identity
  end # module Monads
end # module Tweed