module Tweed
  module Monads
    class List < Tweed::Monad
      define_monad do
        construct { |sequence| @sequence = sequence }
        unit { |value| self.new([value]) }
        bind do |&block|
          self.class.new(@sequence.map do |item|
                           block.call(item).to_a
                         end.inject(&:+))
        end
        zero { self.new([].freeze!) }
      end
      
      def +(other)
        self.class.new(self.to_a + other.to_a)
      end
      
      def inspect
        "#{self.class.inspect} :: #{@sequence.inspect}"
      end
      
      def to_a
        @sequence.to_a
      end
      
      def ==(other)
        self.to_a == other.to_a
      end
    end # class List
  end # module Monads
end # module Tweed